<template>
  <div class="container-fluid">
    <div class="row">
      <div class="col-sm-12">
        <div class="card rounded shadow web-only">
          <div class="col-sm-12 mt-3  d-flex justify-content-between">
            <div class="form-search d-flex align-items-center">
              <i class="fa fa-search" @click="init(0, true)"></i>
              <input
                class="form-control pr-4"
                @keyup.enter="init(0, true)"
                type="search"
                placeholder="Rechercher (Nom Complet)"
                v-model="searchtext"
              />
            </div>
            <div class="form-group mt-4">
              <input
                type="submit"
                class="btn btn-light btn-block"
                value="Ajouter"
              />
            </div>
          </div>
          <div class="p-5" v-if="isLoading">
            <fulfilling-bouncing-circle-spinner
              class="mx-auto"
              :animation-duration="2000"
              :size="60"
              :color="'#6D071A'"
            />
          </div>
          <div v-else>
            <div class="card-body">
              <div class="table-responsive">
                <table class="table rounded">
                  <thead>
                    <th>Nom & Prénom(s)</th>
                    <th>Téléphone</th>
                    <th>Statut</th>
                    <th></th>
                  </thead>
                  <tbody>
                    <tr v-for="(admin, i) in admins" :key="i">
                      <td> {{ admin.fullname }} </td>
                      <td> {{ admin.phone }} </td>
                      <!--  <td> {{ admin.active ? 'activé' : 'désactivé' }} </td>  -->
                      <td v-if=" admin.active">
                        <button type="button" class="btn btn-success btn-sm"
                          @click="changeStatut(admin._id,admin.active)">
                          <!-- <i class="fa fa-redo"></i> -->
                          <i class="las la-sync"></i>
                        </button>
                      </td>
                      <td v-else>
                        <button type="button" class="btn btn-danger btn-sm"
                          @click="changeStatut(admin._id,admin.active)">
                          <!-- <i class="fa fa-redo"></i> -->
                          <i class="las la-sync"></i>
                        </button>
                      </td>
                    </tr>
                  </tbody>
                </table>
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>


<script>
const roles = {
  coordonator: "Cordonateur",
  manager: "Manageur",
  rse: "RSE",
  "rlm-antenne": "RLM Antenne",
  rlm: "RLM",
  admin: "Administrateur",
};
export default {
  name: "home",
  data() {
    return {
      admins: [],
      errorMessage: "",
      newAdmin: {
        earnings: 0,
        historiesPacks: [],
        historiesGetEarnings: [],
        nbreFilleuls: 0,
      },
      creating: false,
      confpassword: "",

      searchtext: "",
      searchtype: "firstname",
      isLoading: false,
      curPage: 1,
      total: 0,
      perPage: 100,
      sort: {},
    };
  },
  mounted() {
    for (var i = 0; i < this.fileNumber; i++) {
      this.importFiles.push({});
      this.imageData.push("");
    }
    this.init();
    this.getPacks();
  },
  filters: {
    getRoleLabel: function (value) {
      return roles[value];
    },
  },
  methods: {
    init(page, resetParams) {
      if (resetParams) {
        this.curPage = 1;
      }

      let query = {
        options: {
          role: "admin",
        },
        filter: {
          text: this.searchtext,
          type: this.searchtype.split("+"),
        },
        sort: this.sort,
        page: this.curPage - 1,
        perPage: this.perPage,
      };

      this.isLoading = true;
      this.$service.listAdmins(query, (err, data) => {
        this.isLoading = false;
        if (err) {
          console.log(err);
          return;
        }
        //console.log(data);
        this.total = data.total;
        this.admins = data.admins;
      });
    },
    showAdmin(id) {
      this.$router.push("/users/detail/" + id);
    },
    changeStatut(id,statut){
      let newStatut = !statut;
      this.$service.updateUser(id,{ active: newStatut},(err, data) => {
          if (err) {
            this.errorMessage = err.data && err.data.message;
            console.log("Error", err.data);
            return;
          }

          let datas = {
            admin : age.getItem("adminId"),

            message: 'change status admin : ' + id,
            date: new Date(),
            position : this.center,
          }
          this.$service.create("historiques", datas, (err, data) => {
            if (err) {
              this.errorMessage = err.data && err.data.message;
              return;
            }
            this.$swal.fire("Statut changé !!!", "", "success").then(() => {
              this.init();
            }); 
          });
        }
      );
    },
    create(e) {
      e.preventDefault();

      if (this.newAdmin.password == this.confpassword) {
        let query = {
          options: {
            _id: this.newAdmin.pack,
          },
        };
        //recup pack selectionné infos
        this.$service.list("packs", query, (err, data) => {
          if (err) {
            this.errorMessage = err.data && err.data.message;
            console.log("Error", err.data);
            return;
          }
          let thePack = data.packs[0];
          //création premier historique des packs
          let currentH = {
            pack: this.newAdmin.pack,
            status: false,
            source: "momo",
          };
          this.newAdmin.historiesPacks.push(currentH);
          //enrégistrement de l'admin
          this.$service.createAdmin(this.newAdmin, (err, data) => {
            if (err) {
              this.errorMessage = err.data && err.data.message;
              console.log("Error", err.data);
              return;
            }
            this.$swal.fire("Utilisateur créé", "", "success").then(() => {
              this.init();
            });
          });
        });
      } else {
        this.errorMessage = "Confirmation mot de passe échouée.";
      }
    },
    removeAdmin(id) {
      this.$swal
        .fire({
          title: "Voulez vous vraiment supprimer?",
          text: "Vous ne pouvez recuperer ses données!",
          icon: "warning",
          showCancelButton: true,
          cancelButtonColor: "#3085d6",
          confirmButtonColor: "#d33",
          confirmButtonText: "Oui, supprimer!",
        })
        .then((result) => {
          if (result.value) {
            this.$service.removeAdmin(id, (err, data) => {
              if (err) {
                this.errorMessage = err.data && err.data.message;
                console.log("Error", err.data);
                return;
              }

              this.$swal
                .fire(
                  "Suppression réussie",
                  "La suppression s'est effectuée avec succès",
                  "success"
                )
                .then(() => {
                  //this.init();
                });
            });
          }
        });
    },
  },
};
</script>
